#!/bin/sh
#***************************************
#* LCD-Ticker                          *
#* (c)theobald123 and Tischi           *
#* Lizenz: GPL 2                       *
#* Version: 2.1                        *
#* Stand: 24.04.2016                   *
#* Speicherort: /var/tuxbox/plugins    *
#***************************************

liga=$1                                 #bergabeparameteraus lcdticker_start.sh
url="http://liveticker.bundesliga.de"   #Datenquelle
logopfad="/var/lcd/lcdticker"           #Verzeichnis fr die Logos
refresh=15                              #Anzeigedauer eines Bildschirms

#**********************************************
#* Datenzeile in einzelne Parameter aufteilen *
#**********************************************
parameter ()
{ 
	pn=$#
	p1=$1
	p2=$2
	p3=$3
	p4=$4
	p5=$5

	if [ "$p5" == "0" ]; then
		p2="-"
		p4="-"
	fi
}

#************************************************
#* Verzeichnisse anlegen und Spieltag ermitteln *
#************************************************
init_lcd ()
{
	mkdir /tmp/lcdticker
	mkdir /tmp/lcdticker/1
	mkdir /tmp/lcdticker/2
	mkdir /tmp/lcdticker/3
	touch /tmp/lcdticker/.ticker_running

	wget -q -O - "$url/$liga" | \
	sed -n -e /\"competition_id\":/p -e /\"season_id\":/p -e /\"matchday\":/p | \
	sed -e 's/^.*://g' -e 's/,.*$//g' -e 's/\"//g' > /tmp/lcdticker/ticker.txt
	co=`sed -n 1p /tmp/lcdticker/ticker.txt`;co=`echo $co`;co=`echo "co"$co`
	se=`sed -n 2p /tmp/lcdticker/ticker.txt`;se=`echo $se`;se=`echo "se"$se`
	md=`sed -n 3p /tmp/lcdticker/ticker.txt`;md=`echo $md`;md=`echo "md"$md`

	if [ ! -d /var/lcd/lcdticker/$co/$se ]; then
		init_logos
	fi
}

#*************************************
#* einmaliges Laden der Vereinslogos *
#*************************************
init_logos ()
{
	msgbox size=22 timeout=10 popup="Vereinslogos werden geladen"
	rm    -rf $logopfad/$co
	mkdir -p  $logopfad/$co/$se

	wget -q -O - "$url/json_ranking/$co/$se/" | \
	sed	-e 's/\}/\n/g' | \
	sed -e 's/^.*\id//g' \
			-e 's/games.*$//g' \
			-e 's/\"//g' \
			-e 's/\://g' \
			-e 's/\]//g' \
			-e 's/\,//g' > /tmp/lcdticker/ticker.txt

	count=1
	while [ $count -le 18 ]; do
		logo=`sed -n "$count"p /tmp/lcdticker/ticker.txt`;logo=`echo $logo`
		wget -q -O - "$url/global/gfx/emblem/dfl/60x60/$logo.png" > $logopfad/$co/$se/$logo.png
		count=`expr "$count" + 1`
	done
}

#********************
#* Ergebnisse holen *
#********************
get_url ()
{
	wget -q -O - "$url/json_live/$co/$se/$md" | \
	sed -n -e /\"event\"/p | \
	sed -e 's/},/},\n/g' | \
	sed -e 's/^.*\"home\":\"//g' \
		-e 's/\",\"home_score\":\[/ /g' \
		-e 's/\],\"home_color.*away\":\"/ /g' \
		-e 's/\",\"away_score\":\[/ /g' \
		-e 's/\],\"away_color.*attendance\":\"/ /g' \
		-e 's/\"\}.*$//g' | \
	sed	-e 's/\,../ /g' > /tmp/lcdticker/ticker.txt
}

#***************************
#* auf 3 Screens aufteilen *
#***************************
dispatch_logos ()
{
	get_url
	
	#************
	#* Screen 1 *
	#************
	paarung=`sed -n 1p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/1/A.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/1/B.png

	paarung=`sed -n 2p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/1/C.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/1/D.png

	paarung=`sed -n 3p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/1/E.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/1/F.png

	#************
	#* Screen 2 *
	#************
	paarung=`sed -n 4p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/2/A.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/2/B.png

	paarung=`sed -n 5p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/2/C.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/2/D.png

	paarung=`sed -n 6p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/2/E.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/2/F.png

	#************
	#* Screen 3 *
	#************
	paarung=`sed -n 7p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/3/A.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/3/B.png

	paarung=`sed -n 8p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/3/C.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/3/D.png

	paarung=`sed -n 9p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
	parameter $paarung
	cp $logopfad/$co/$se/$p1.png  /tmp/lcdticker/3/E.png
	cp $logopfad/$co/$se/$p3.png  /tmp/lcdticker/3/F.png
}

#****************************************
#* Ergebnisdatei erstellen und anzeigen *
#****************************************
get_results ()
{
	while [ -e /tmp/lcdticker/.ticker_running ]; do
		get_url
		#************
		#* Screen 1 *
		#************
		paarung=`sed -n 1p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 > /tmp/lcdticker/1/result.txt

		paarung=`sed -n 2p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/1/result.txt

		paarung=`sed -n 3p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/1/result.txt

		#************
		#* Screen 2 *
		#************
		paarung=`sed -n 4p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 > /tmp/lcdticker/2/result.txt

		paarung=`sed -n 5p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/2/result.txt

		paarung=`sed -n 6p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/2/result.txt

		#************
		#* Screen 3 *
		#************
		paarung=`sed -n 7p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 > /tmp/lcdticker/3/result.txt

		paarung=`sed -n 8p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/3/result.txt

		paarung=`sed -n 9p /tmp/lcdticker/ticker.txt`;paarung=`echo $paarung`
		parameter $paarung
		echo $p2":"$p4 >> /tmp/lcdticker/3/result.txt

		#*************************
		#* Screens durchwechseln *
		#*************************
		count=1
		while [ $count -le 3 ]; do
			cp /tmp/lcdticker/$count/*.* /tmp/lcdticker
			sleep $refresh
			count=`expr "$count" + 1`
		done
	done
}

rm -rf /tmp/lcdticker
init_lcd
dispatch_logos
cp /tmp/lcdticker/1/*.* /tmp/lcdticker
killall lcd4linux
sleep 3
lcd4linux -f /var/lcd/lcdticker.conf
get_results
exit
